<?php

/**
 * Implementiert die Einstellung  der zeitrelevante Parameter
 * @author Miguel Palmer <mp@beronet.com>
 */
class TimeConf {

	/**
	 * Generates the timezone otions
	 * @return string
	 */
	function options() {
		$bc = new beroConf('root');
		$arr_text = array("(GMT -12:00) Eniwetok, Kwajalein", "(GMT -11:00) Midway Island, Samoa",
			"(GMT -10:00) Hawaii", "(GMT -9:00) Alaska", "(GMT -8:00) Pacific Time (US &amp; Canada)",
			"(GMT -7:00) Mountain Time (US &amp; Canada)", "(GMT -6:00) Central Time (US &amp; Canada), Mexico City",
			"(GMT -5:00) Eastern Time (US &amp; Canada), Bogota, Lima", "(GMT -4:00) Atlantic Time (Canada), Caracas, La Paz",
			"(GMT -3:30) Newfoundland", "(GMT -3:00) Brazil, Buenos Aires, Georgetown",
			"(GMT -2:00) Mid-Atlantic", "(GMT -1:00 hour) Azores, Cape Verde Islands",
			"(GMT) Western Europe Time, London, Lisbon, Casablanca", "(GMT +1:00) Berlin, Brussels, Copenhagen, Madrid, Paris",
			"(GMT +2:00) Kaliningrad, South Africa", "(GMT +3:00) Baghdad, Riyadh, Moscow, St. Petersburg",
			"(GMT +3:30) Tehran", "(GMT +4:00) Abu Dhabi, Muscat, Baku, Tbilisi",
			"(GMT +4:30) Kabul", "(GMT +5:00) Ekaterinburg, Islamabad, Karachi, Tashkent",
			"(GMT +5:30) Bombay, Calcutta, Madras, New Delhi", "(GMT +5:45) Kathmandu",
			"(GMT +6:00) Almaty, Dhaka, Colombo", "(GMT +7:00) Bangkok, Hanoi, Jakarta",
			"(GMT +8:00) Beijing, Perth, Singapore, Hong Kong", "(GMT +9:00) Tokyo, Seoul, Osaka, Sapporo, Yakutsk",
			"(GMT +9:30) Adelaide, Darwin", "(GMT +10:00) Eastern Australia, Guam, Vladivostok",
			"(GMT +11:00) Magadan, Solomon Islands, New Caledonia", "(GMT +12:00) Auckland, Wellington, Fiji, Kamchatka");

		$arr_val = array("+12", "+11", "+10", "+9", "+8", "+7", "+6", "+5", "+4", "+3.5", "+3", "+2", "+1", "+0",
			"-1", "-2", "-3", "-3.5", "-4", "-4.5", "-5", "-5.5", "-5.75", "-6", "-7", "-8", "-9", "-9.5", "-10", "-11", "-12");
		$sp = $bc->get("root", "timezone");
		$options = "";
		for ($i = 0; $i < count($arr_val); $i++) {
			($arr_val[$i] == $sp) ? $selected = "selected" : $selected = "";
			$options .= "<option value='" . $arr_val[$i] . "' " . $selected . ">" . $arr_text[$i] . "</option>";
		}
		return $options;
	}

	/**
	 * Generates the options for the time from isdn dropdown menu
	 * @return string
	 */
	function ports($def = 0) {
		$ba = new beroAri();
		$options = "<option value='no'>Disabled</option>";
		$query = $ba->select("select port from isdn");
		while ($ports = $ba->fetch_array($query)) {
			if ($def == $ports['port']) {
				$options .= "<option value='" . $ports['port'] . "' selected>Port " . $ports['port'] . "</option>";
			} else {
				$options .= "<option value='" . $ports['port'] . "'>Port " . $ports['port'] . "</option>";
			}
		}
		return $options;
	}

	/**
	 * Saves the time setting to the database
	 * @param beroConf $bc
	 * @param beroAri $ba
	 * @return string
	 */
	function save($bc, $ba) {
		$ret .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
		$ntp = $bc->get("root", "gui-ntphost");
		$bc->set("root", "gui-ntphost", sqlite_escape_string($_POST['ntphost']));
		$bc->set("root", "ntphost", sqlite_escape_string($_POST['ntphost']));
		$bc->set("root", "timezone", sqlite_escape_string($_POST['timezone']));

		if ($_POST['time_from_isdn'] != "no") {
			$bc->set("root", "time_from_isdn", $_POST['time_from_isdn']);
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$ret .= "<br/><div class='text-center'>" . $isgw->itpX($_POST['time_from_isdn']) . "</div><br/>";
			$bc->set("root", "timezone", "0");
			$bc->set("root", "ntphost", "");
			$ba->set("summer_winter_time", "0");
			system("/bin/mount -o remount,rw /;
	 			/bin/echo \"GMT0\" > /etc/TZ;
 	 			/bin/mount -o remount,ro /;
 	 			/bin/sync;");
			$bc->set("root", "ntphost", "");
			$bc->set("root", "gui-ntphost", "");
		} else {
			//Seite beim Timeout des servers neuladen wenn der ntp host sich verändert hat
			if ($ntp != $_POST['ntphost'])
				echo '<script>
                            setTimeout(function () {
                                location.href = location.href;
                            }, 500);  // just reloads the page
                        </script>';
			if ($_POST['summer_winter_time'] == "1") {
				$ba->set("summer_winter_time", "1");
				system("/bin/mount -o remount,rw /;
	 				/bin/echo \"CET" . $_POST['timezone'] . "CEST,M3.5.0/02:00:00,M10.5.0/03:00:00\" > /etc/TZ;
 	 				/bin/mount -o remount,ro /;
 	 				/bin/sync;");
			} else {
				$ba->set("summer_winter_time", "0");
				system("/bin/mount -o remount,rw /;
	 				/bin/echo \"GMT" . ($_POST['timezone']) . "\" > /etc/TZ;
 	 				/bin/mount -o remount,ro /;
 	 				/bin/sync;");
			}
			$bc->set("root", "time_from_isdn", "no");
			$bc->set("root", "timezone", sqlite_escape_string($_POST['timezone']));
			$bc->set("root", "ntphost", sqlite_escape_string($_POST['ntphost']));
			$bc->set("root", "gui-ntphost", sqlite_escape_string($_POST['ntphost']));
			if ($_POST['ntphost'] != "")
				exec("/usr/local/init/S03acl allow_timeserver \"" . $_POST['ntphost'] . "\"");

			exec("/usr/sbin/update-time");
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->itpX("no");
			$ret .= "<br/><div class='text-center'>" . Helper::getDate() . "</div><br/>";
		}
		return $ret;
	}

	/**
	 * Generates the HTML page
	 * @return string
	 */
	function display() {

		include '/usr/fallback/beroConf.php';
		require_once ('./includes/isgwtelnet.php');
		$bc = new beroConf('root');
		$ba = new beroAri();

		$name = "TIME_TITLE_DIS";
		include('./includes/header.php');
		require_once("./includes/lang.php");

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		if (!$bc->valid()) {
			$ret .= '<h3>Error:</h3><b>Failed to connect to config database!</b><br>';
			exit(0);
		}

		//Save settings
		if ($_POST['action'] == "save") {
			$ret .= $this->save($bc, $ba);
		}
		if ($ba->get('gui_mode') == 'simple') {
			$simple_class = 'simple';
		}
		if ($ba->get("summer_winter_time") == "1" || $ba->get("summer_winter_time") == "yes") {
			$summerTime = "checked";
		}
		ob_start();
		?>

		<script>
		    function tfi(ch) {
		        if (ch != 0) {
		            document.getElementById('ntphost').style.display = 'none';
		            document.getElementById('tz').style.display = 'none';
		            document.getElementById('summer_winter').style.display = 'none';
		        } else {
		            document.getElementById('ntphost').style.display = '';
		            document.getElementById('tz').style.display = '';
		            document.getElementById('summer_winter').style.display = '';
		        }

		    }
		</script>
		<br>
		<form  name="timeform" id="timeform" class="form-horizontal" method="POST" action="">
			<input type="hidden" name="action" value="save">
			<p class="text-center lead" ><? echo TIME_TABLE_HEADER_DIS ?></p>

			<?if (!in_array($bc->get('root', 'lan-dhcp'), array('yes', '1'))) {?>
			<div class='form-group' id="ntphost">
				<label for='ntphost' class='col-sm-5 control-label'><? echo TIME_NTP_HOST_DIS ?></label>
				<div class='col-sm-4'>
					<input name="ntphost" class="form-control input-sm" type="text" size="15" id="ntphost" value="<? echo $bc->get("root", "gui-ntphost") ?>">
				</div>
			</div>
			<?}?>
			<div class='form-group' id="tz">
				<label for='timezone' class='col-sm-5 control-label'><? echo TIME_TIMEZONE_DIS ?></label>
				<div class='col-sm-4'>
					<select name="timezone" class="form-control input-sm" id="timezone">
						<? echo $this->options() ?>
					</select>
				</div>
			</div>
			<div class='form-group' id="summer_winter">
				<label for='summer_winter_time' class='col-sm-5 control-label'><? echo TIME_SUMMER_WINTER_DIS ?></label>
				<div class='col-sm-4'>
					<input type="hidden" name="summer_winter_time" id="summer_winter_time" value="0">
					<input type="checkbox" name="summer_winter_time" id="summer_winter_time" value="1" <? echo $summerTime ?>>
				</div>
			</div>

			<div class="form-group <? echo $simple_class ?>" >
				<label for='time_from_isdn' class='col-sm-5 control-label'><? echo TIME_TIME_FROM_ISDN_DIS ?></label>
				<div class='col-sm-4'>
					<select name="time_from_isdn" class="form-control input-sm" id="time_from_isdn" 
							onclick="tfi(time_from_isdn.selectedIndex);">
								<? echo $this->ports($bc->get("root", "time_from_isdn")) ?>
					</select>
				</div>
			</div>
			<br>
			<div class="text-center">
				<input type="submit" class="btn btn-default" name="Apply" value="<? echo BUTTON_SAVE ?>">
			</div>
		</form>
		<script>
		    $("#timeform").validate({

		        rules: {
		            ntphost: {
		                checkHostname: true,
		            },
		        }
		    });
		    tfi(document.getElementById("time_from_isdn").selectedIndex);
		</script>
		<?
		$ret .= ob_get_clean();

		return $ret;
	}

}
?>
